<?php 
/**
 * pragmaMx  Content Management System
 * Copyright (c) 2007 pragmaMx Dev Team - http://pragmaMx.org
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
defined('mxMainFileLoaded') or die('access denied');
include_once(PMX_MODULES_DIR . DS . basename(dirname(__file__)) ."/settings.php");

$uinfo = mxGetUserData();  

if (class_exists('pmxHeader', false)){
/**
 * pmxHeader_Site_map
 * 
 * @package pragmaMx
 * @author algebre
 * @copyright 2010
 * @version $Id$
 * @access public
 */
class pmxHeader_Site_map extends pmxHeader
{
    private  $jquery_path;
    function __construct() {

    }

    public static function add_treeview($cookie = true)
    {
        global $treeview_anime_speed, $treeview_use_anime, $treeview_use_cookie, $module_name, $bgcolor2;
        $jquery_path =  PMX_JAVASCRIPT_PATH . 'jquery/';
        if (method_exists('pmxHeader','add_jquery')){//that mean this version is equal or higher than 0.1.12.0
            parent::add_jquery();
            parent::add_script($jquery_path . 'jquery.treeview.js');
            parent::add_style( $jquery_path . 'jquery.treeview.css');
            parent::add_script_code('$(function() {
			$("#tree").treeview({
				collapsed: true,
				' .(($treeview_use_anime == 1) ?   'animated: "'.$treeview_anime_speed.'",' : ''). '
				control:"#sidetreecontrol",
				' .(($treeview_use_cookie == 1) ?   'persist: "cookie"' : ''). '
			});
		})
		');
            
        }else {
            parent::add_script($jquery_path . 'jquery.js');
            parent::add_script($jquery_path . 'jquery.treeview.js');
            parent::add_style( $jquery_path . 'jquery.treeview.css');
        }
        if ($cookie)
        {
            parent::add_script($jquery_path . 'lib/jquery.cookie.js');
        }
        parent::add_style_code('
#sitemap{
    margin:0 20px;
    }
.treeview, .treeview ul { 
	padding: 0;
	margin: 0;
	list-style: none;
}

.treeview ul {
	background-color: '.((MX_MODULE == $module_name) ? 'transparent' : $bgcolor2).';
	margin-top: 4px;
}');
        }
}
}

/**
 * callMapModule()
 * 
 * @param string $modulename
 * @param integer $map_limit
 * @param mixed $specificmodulearg
 * @return call function mapModulename($modulename, $map_limit, $specificmodulearg)
 */
function callMapModule($modulename, $map_limit = 10, $specificmodulearg){
    if(!$modulename) return;
if (function_exists('map'. $modulename)){
 call_user_func('map'. $modulename, $modulename, $map_limit, $specificmodulearg);   
}
}

/**
 * function altDisplay()
 * @param string $linkdescription
 * @param string $linkTitle
 * @return string $linkTitle OR formated $linkdescription
 */

 
 function altDisplay($linkdescription = '',$linkTitle ='', $hits = ''){
	global $link_alt, $link_alt_long;
    if ($link_alt == 1){    
          $linkdescription = mxCutString(trim(strip_tags($linkdescription)),$link_alt_long + 50);   
           $linkdescription = preg_replace('/\s\s+/', ' ', $linkdescription);
            return $linkdescription;
    }else 
          if($hits!='') {$hit = ' :::: ' . _HITS . ' = ' . $hits;}else $hit = '';
          $linkdescription = mxCutString($linkTitle, $link_alt_long) . $hit;
           return $linkdescription;
}
 

define('MX_ADMINPANEL_SYSTEM', 1);
define('MX_ADMINPANEL_CONTENT', 2);
define('MX_ADMINPANEL_SECURITY', 3);
define('MX_ADMINPANEL_USERS', 4);
define('MX_ADMINPANEL_ADDON', 5);
        
/**
 * mapAdmin()
 * 
 * @return
 */
function mapAdmin(){
    if(!MX_IS_ADMIN) {
        global $prefix, $uinfo;
        $qry = "SELECT aid FROM ".$prefix."_authors WHERE user_uid=" . intval($uinfo['uid']) . " AND radminsuper='1'";
        $result = sql_fetch_array(sql_query($qry));
        if(!$result) return;?>
        <li><a href="admin.php" title="<?php echo _HELLO .' ' . $result['aid'] .' '. _LOGIN; ?>"><strong><?php echo _ADMINMENUEBL; ?></strong></a>
        <?php
        return;
        
        }
    mxGetLangfile('admin');
    
      if (!defined("mxAdminFileLoaded")) define("mxAdminFileLoaded" , 1);
      $nav_item = array(1 => array('url' => 'admin.php?panel=system',
            'class' => 'tabs-nav-sys',
            'title' => _SYSTEM,
            'description' => _SYSTEM_DESCR,
            ),
        2 => array('url' => "admin.php?panel=content",
            'class' => 'tabs-nav-con',
            'title' => _CONTENT,
            'description' => _CONTENT_DESCR,
            ),
        3 => array('url' => "admin.php?panel=security",
            'class' => 'tabs-nav-sec',
            'title' => _SECURITY,
            'description' => _SECURITY_DESCR,
            ),
        4 => array('url' => "admin.php?panel=users",
            'class' => 'tabs-nav-use',
            'title' => _USERS,
            'description' => _USER_DESCR,
            ),
        5 => array('url' => "admin.php?panel=addon",
            'class' => 'tabs-nav-add',
            'title' => _ADDON,
            'description' => _ADDON_DESCR,
            ),
        );
      global $thelinks; 
      $admindata = mxGetAdminData();
        extract($admindata);
        
        
        $thelinks = array();
        foreach ((array)glob(PMX_ADMIN_DIR . DS . 'links' . DS . 'links.*.php', GLOB_NOSORT) as $filename) {
            /* Datei einlesen, hier wird jeweils die funktion adminmenu() ausgefuehrt */
            if ($filename) {
                include_once($filename);
            }
        }
?>
<li><a href="admin.php" title="<?php echo _ADMINISTRATION; ?>"><strong><?php echo _ADMINISTRATION; ?></strong></a>
	<ul>
    <?php foreach ($thelinks as $cat => $links): ?> 
      <li>
       <a href="<?php echo $nav_item[$cat]['url']; ?>" title="<?php echo $nav_item[$cat]['description']; ?>"><?php echo $nav_item[$cat]['title']; ?></a>
                   <ul>
<?php foreach ($links as $link): ?>
                <li>
                <a href="<?php echo $link['url']; ?>" title="<?php echo $link['title']; ?>"><?php echo $link['title']; ?></a>
                </li>
<?php endforeach ?>
            </ul>
       
       </li> 
        <?php endforeach ?>
    </ul>
 </li>
<?php

}
if (!function_exists('adminmenu')){
    
        function adminmenu($url = '', $title = '', $image = null, $panel = MX_ADMINPANEL_ADDON){
            global $thelinks;
            $thelinks[$panel][] = array('url' => $url,
                                        'title' => $title,
                                        'panel'=>$panel
            );
            return $thelinks;
    }
}
//adminmenu("admin.php?op=topicsmanager", _TOPICSMANAGER, "topicsman.gif", MX_ADMINPANEL_CONTENT);

###############################################################
/**
 * function : mapContent()
 * @param  string $module_name Default 'Content'
 * @param  integer $map_limit Default '30'
 * @param  string $output Default 'echo'
 * @return string $out (Categories & items as list <lu><li>)
 */
function mapContent($module_name = 'Content', $map_limit = 30)
{
    global $prefix, $currentlang, $custom_title, $map_output;
    $print = array();
    $qry = "SELECT link.cid as cat_id, link.title as link_title, link.pid as link_id, 
            link.counter as link_hits, cat.title as cat_title, cat.description as cat_desc,
            IF(link.subtitle<>'', link.subtitle, link.page_header) as link_desc
            FROM " . $prefix . "_pages AS link
            LEFT JOIN " . $prefix . "_pages_categories AS cat ON (link.cid = cat.cid)
            WHERE active= '1' AND (link.clanguage LIKE '" . $currentlang . "%' OR link.clanguage='')
            ORDER BY link.cid, link.pid  LIMIT " . intval($map_limit) . "
    ";
     $result = sql_query($qry);
     if (!$result) return;
     while ($row = sql_fetch_assoc($result)) {
     $row['link_desc']  = htmlentities ($row['link_desc']);
     $row['link_title'] = htmlentities ($row['link_title']);
     $row['link_desc'] = altDisplay($row['link_desc'], $row['link_title'], $row['link_hits']);
     $row['href_cat']  = 'modules.php?name=' . $module_name . '&amp;cid=' . $row['cat_id'];
     $row['href_link'] = 'modules.php?name=' . $module_name . '&amp;pid=' . $row['link_id']; 
     if($row['cat_id'] == '0'){
        $row['cat_title'] = _NONCLASSCONT;
        $row['cat_desc'] = _NONCLASSCONT;
        $row['cat_desc'] = _NONCLASSCONT;
        $row['href_cat']  = 'modules.php?name=' . $module_name;
     }
     $print[$row['cat_id']][] = $row;
}
    // output

   return _mapTemplate($print, $module_name); 
}
/**
 * function : mapNews()
 * @param  string $module_name
 * @param  integer $map_limit
 * @param  string $output
 * @return mixed $out
 */
function mapNews($module_name = 'News', $map_limit = 30)
{
    global $prefix, $currentlang, $map_output;
    $print = array();
  
    $qry = "SELECT catid as cat_id, title as link_title, sid as link_id, 
            counter as link_hits, hometext as link_desc
            FROM " . $prefix . "_stories AS link
            WHERE catid='0' AND `time` <= now() AND (alanguage LIKE '" . $currentlang . "%' OR alanguage='')
            ORDER BY time, sid  LIMIT " . intval($map_limit) . "
    ";

     $result = sql_query($qry);
     while ($row = sql_fetch_assoc($result)) {
     $row['link_desc']  = altDisplay($row['link_desc'], $row['link_title'], $row['link_hits']);
     $row['link_desc']  = htmlentities ($row['link_desc']);
     $row['link_title'] = htmlentities ($row['link_title']);
     $row['href_cat']   = 'modules.php?name=' . $module_name;
     $row['href_link']  = 'modules.php?name=' . $module_name . '&amp;file=article&amp;sid=' . $row['link_id']; 
     $row['cat_title']  = _MAPARTICLES;
     $row['cat_desc']   = _MAPARTICLES;
     $print[$row['cat_id']][] = $row;

}

    ############################################################################
    $qry = "SELECT DISTINCT link.catid as cat_id, link.title as link_title, link.sid as link_id, 
            link.counter as link_hits, cat.title as cat_title,  cat.title as cat_desc,
            link.hometext as link_desc, cat.catid as cat_id
            FROM " . $prefix . "_stories AS link
            LEFT JOIN " . $prefix . "_stories_cat AS cat ON (link.catid = cat.catid)
            WHERE link.catid !='0' AND link.time <= now() AND (link.alanguage LIKE '" . $currentlang . "%' OR link.alanguage='')
            ORDER BY link.time, link.sid  LIMIT " . intval($map_limit) . "
    ";

     $result = sql_query($qry);
     while ($row = sql_fetch_assoc($result)) {
     $row['link_desc'] = altDisplay($row['link_desc'], $row['link_title'], $row['link_hits']);
     $row['link_desc'] = htmlentities ($row['link_desc']);
     $row['link_title'] = htmlentities ($row['link_title']);
     $row['href_cat']  = 'modules.php?name=' . $module_name . '&amp;file=categories&amp;catid=' . $row['cat_id'];
     $row['href_link'] = 'modules.php?name=' . $module_name . '&amp;file=article&amp;sid=' . $row['link_id']; 
     $print[$row['cat_id']][] = $row;

}
   //$print = array_merge($print1, $print2);
    ksort($print);
    unset($qry, $result, $row) ;
    return _mapTemplate($print, $module_name);
}


/**
 * function : searchform
 */
function mapSearch($module_name = 'Search', $map_limit = 10, $specificmodulearg = 'Simple')
{
$search_module = array(
                       'Content' => array('content' , _CONTENT),
                       'Sections' => array('sections', _SECTIONS),
                       'My_eGallery' => array('galerie' , _GALLERY),
                       'Members_List' => array('users' , _MAPSUSERS)//_SUSERS
);
 switch ($specificmodulearg): 
        case 'Advanced': ?>
            <ul><li>
                <form action="modules.php" method="get">
                    <table>
                        <tr valign="top">
                            <td>
                                <fieldset><?php echo _MAPSEARCHIN; ?><br />
    <?php if (mxModuleAllowed('News')): ?>
                                    <input type="radio" value="stories" checked="checked" name="type" /><?php echo _NEWSARTICLES; ?> <br />	
                                    <input type="radio" value="comments" name="type" /><?php echo _COMMENTS; ?> <br />	   
    <?php endif ?>
<?php foreach ($search_module as $modname => $value ) : ?>
    <?php if (mxModuleAllowed($modname)): ?>
                                    <input type="radio" value="<?php echo $value[0]; ?>" name="type" /><?php echo $value[1]; ?> <br />	
<?php endif ?>
<?php endforeach ?>


                                    <input type="hidden" name="name" value="<?php echo $module_name; ?>" />
                                    <input type="text" name="query" size="20" title="<?php echo _SEARCH; ?>" />
                                    <input type="submit" value="<?php echo _SEARCH; ?>" title="<?php echo _SEARCH; ?>" />
                                </fieldset>
                            </td>
                        </tr>
                    </table>
                </form>
            </li></ul>
	<?php break; ?>
    
	<?php default : ?>
            <ul><li>
                <form action="modules.php" method="get" title="<?php echo _SEARCH; ?>">
                    <p>
                        <input type="hidden" name="name" value="<?php echo $module_name; ?>" />
                        <input type="text" name="query" size="20" title="<?php echo _SEARCH; ?>" />
                        <input type="submit" value="<?php echo _SEARCH; ?>" title="<?php echo _SEARCH; ?>" />
                    </p>
                </form>        
            </li></ul>

<?php endswitch; ?>

<?php

} 



/**
 * function : mapWeb_Links()
 * @param  string $module_name Default 'Web_Links'
 * @param  integer $map_limit Default '30'
 * @param  string $output Default 'echo'
 * @return string $out (Categories & items as list <lu><li>)
 */

function mapWeb_Links($module_name = 'Web_Links', $map_limit = 30)
{
    global $prefix, $custom_title, $map_output;
    $print = array();
    $qry = "SELECT link.cid as cat_id, link.title as link_title, link.lid as link_id, 
            link.hits as link_hits, link.description as link_desc,cat.title as cat_title, 
            cat.cdescription as cat_desc
            FROM " . $prefix . "_links_links AS link
            LEFT JOIN " . $prefix . "_links_categories AS cat ON (link.cid = cat.cid)
            ORDER BY link.cid, link.lid  LIMIT " . intval($map_limit) . "
    ";
    $result = sql_query($qry);
    if (!$result) return;
     while ($row = sql_fetch_assoc($result)) {
     $row['link_desc'] = altDisplay($row['link_desc'], $row['link_title'], $row['link_hits']);
     $row['link_desc']  = htmlentities ($row['link_desc']);
     $row['link_title'] = htmlentities ($row['link_title']);
     $row['href_cat']  = 'modules.php?name=' . $module_name . '&amp;cid=' . $row['cat_id'];
     $row['href_link'] = 'modules.php?name=' . $module_name . '&amp;op=view&amp;lid=' . $row['link_id'];
     if($row['cat_id'] == '0'){
        $row['cat_title'] = _NONCLASSCONT;
        $row['cat_desc'] = _NONCLASSCONT;
        $row['cat_desc'] = _NONCLASSCONT;
        $row['href_cat']  = 'modules.php?name=' . $module_name;
     }
     $print[$row['cat_id']][] = $row;
}
     $href_cat = '&amp;cid=';
     $href_link ='&amp;op=view&amp;lid=';
    // output

   return _mapTemplate($print, $module_name);
}







/**
 * function : mapDownloads()
 * @param  string $module_name
 * @param  integer $map_limit
 * @param  string $output
 * @return mixed $out
 */
function mapDownloads($module_name = 'Downloads', $map_limit = 30, $specificmodulearg = '')
{
     //global $prefix, $custom_title, $link_alt_long,$link_alt;
     global $prefix, $custom_title, $map_output;
    $print = array();
    $qry = "SELECT link.cid as cat_id, link.title as link_title, link.lid as link_id, 
            link.hits as link_hits, link.description as link_desc,cat.title as cat_title, 
            cat.cdescription as cat_desc
            FROM " . $prefix . "_downloads_downloads AS link
            LEFT JOIN " . $prefix . "_downloads_categories AS cat ON (link.cid = cat.cid)
            ORDER BY link.cid, link.lid  LIMIT " . intval($map_limit) . "
    ";
    $result = sql_query($qry);
    if (!$result) return;
     while ($row = sql_fetch_assoc($result)) {
     $row['link_desc'] = altDisplay($row['link_desc'], $row['link_title'], $row['link_hits']);
     $row['link_desc']  = htmlentities ($row['link_desc']);
     $row['link_title'] = htmlentities ($row['link_title']);
     $row['href_cat']  = 'modules.php?name=' . $module_name . '&amp;cid=' . $row['cat_id'];
     $row['href_link'] = 'modules.php?name=' . $module_name . '&amp;op=view&amp;lid=' . $row['link_id'];
     if($row['cat_id'] == '0'){
        $row['cat_title'] = _NONCLASSCONT;
        $row['cat_desc'] = _NONCLASSCONT;
        $row['cat_desc'] = _NONCLASSCONT;
        $row['href_cat']  = 'modules.php?name=' . $module_name;
     }
     $print[$row['cat_id']][] = $row;
}
     $href_cat = '&amp;cid=';
     $href_link ='&amp;op=view&amp;lid=';//&op=view&lid=5
    // output
   
   return _mapTemplate($print, $module_name);
}


/**
 * function : mapSections()
 * @param  string $module_name Default 'Sections'
 * @param  integer $map_limit Default '30'
 * @param  string $output Default 'echo'
 * @return string $out (Categories & items as list <lu><li>)
 */
function mapSections($module_name = 'Sections', $map_limit = 30)
{
    global $prefix, $currentlang, $custom_title, $map_output;
    $print = array();
    $qry = "SELECT link.secid as cat_id, link.title as link_title, link.artid as link_id, 
            link.counter as link_hits, cat.secname as cat_title, cat.secname as cat_desc,
            link.content as link_desc
            FROM " . $prefix . "_seccont AS link
            LEFT JOIN " . $prefix . "_sections AS cat ON (link.secid = cat.secid)
            WHERE (link.slanguage LIKE '" . $currentlang . "%' OR link.slanguage='')
            ORDER BY link.secid, link.artid  LIMIT " . intval($map_limit) . "
    ";
     $result = sql_query($qry);
     if (!$result) return;
     while ($row = sql_fetch_assoc($result)) {
     $row['link_desc'] = altDisplay($row['link_desc'], $row['link_title'], $row['link_hits']);
     $row['link_desc']  = htmlentities ($row['link_desc']);
     $row['link_title'] = htmlentities ($row['link_title']);
     $row['href_cat']  = 'modules.php?name=' . $module_name . '&amp;secid=' . $row['cat_id'];
     $row['href_link'] = 'modules.php?name=' . $module_name . '&amp;artid=' . $row['link_id'];
     $print[$row['cat_id']][] = $row;
}
     $href_cat = '&amp;secid=';//modules.php?name=Sections&secid=1
     $href_link ='&amp;artid=';//modules.php?name=Sections&artid=1
    // output

   return _mapTemplate($print, $module_name); 
}



/**
 * function : mapEncyclopedia()
 * @param  string $module_name Default 'Encyclopedia'
 * @param  integer $map_limit Default '30'
 * @param  string $output Default 'echo'
 * @return string $out (Categories & items as list <lu><li>)
 */
function mapEncyclopedia($module_name = 'Encyclopedia', $map_limit = 30)
{
    global $prefix, $currentlang, $custom_title, $map_output;
    $print = array();
    $qry = "SELECT link.tid as cat_id, link.title as link_title, link.eid as link_id, 
            link.counter as link_hits, cat.title as cat_title, cat.title as cat_desc,
            link.text as link_desc
            FROM " . $prefix . "_encyclopedia_text AS link
            LEFT JOIN " . $prefix . "_encyclopedia AS cat ON (link.tid = cat.eid)
            WHERE (cat.elanguage LIKE '" . $currentlang . "%' OR cat.elanguage='')
            ORDER BY link.tid, link.eid  LIMIT " . intval($map_limit) . "
    ";
     $result = sql_query($qry);
     if (!$result) return;
     while ($row = sql_fetch_assoc($result)) {
     $row['link_desc'] = altDisplay($row['link_desc'], $row['link_title'], $row['link_hits']);
     $row['link_desc']  = htmlentities ($row['link_desc']);
     $row['link_title'] = htmlentities ($row['link_title']);
     $row['href_cat']  = 'modules.php?name=' . $module_name . '&amp;op=list_content&amp;eid=' . $row['cat_id'];
     $row['href_link'] = 'modules.php?name=' . $module_name . '&amp;op=content&amp;tid=' . $row['link_id'];
     $print[$row['cat_id']][] = $row;
}
     $href_cat = '&amp;op=list_content&amp;eid=';//modules.php?name=Encyclopedia&ampop=list_content&ampeid=1
     $href_link ='&amp;op=content&amp;tid=';//modules.php?name=Encyclopedia&ampop=content&amptid=1
    // output

   return _mapTemplate($print, $module_name); 
}


/**
 * function : mapFAQ()
 * @param  string $module_name Default 'FAQ'
 * @param  integer $map_limit Default '30'
 * @param  string $output Default 'echo'
 * @return string (Categories & items as formated html list <lu><li>)
 */
function mapFAQ($module_name = 'FAQ', $map_limit = 30)
{
    global $prefix, $currentlang, $custom_title, $map_output;
    $print = array();
    $qry = "SELECT link.id_cat as cat_id, link.question as link_title, link.id as link_id, 
            cat.categories as cat_title, cat.categories as cat_desc, answer as link_desc
            FROM " . $prefix . "_faqanswer AS link
            LEFT JOIN " . $prefix . "_faqcategories AS cat ON (link.id_cat = cat.id_cat)
            WHERE (cat.flanguage LIKE '" . $currentlang . "%' OR cat.flanguage='')
            ORDER BY link.id_cat, link.id  LIMIT " . intval($map_limit) . "
    ";
     $result = sql_query($qry);
     if (!$result) return;
     while ($row = sql_fetch_assoc($result)) {
         $row['link_hits'] = '';
     $row['link_desc'] = altDisplay($row['link_desc'], $row['link_title'], $row['link_hits']);
     $row['link_desc']  = htmlentities ($row['link_desc']);
     $row['link_title'] = htmlentities ($row['link_title']);
     $row['href_cat']  = 'modules.php?name=' . $module_name . '&amp;cat=' . $row['cat_id'];
     $row['href_link'] = 'modules.php?name=' . $module_name . '&amp;cat=' . $row['cat_id'] . '#f' . $row['link_id'];
     $print[$row['cat_id']][] = $row;
     //$print['cat_id']['link_id'] = '&amp;cat=' . $row['cat_id']['cat_id'] . '#' . $row['cat_id']['link_id'];
}
    
     $href_cat = '&amp;cat=';//modules.php?name=FAQ&cat=1
     $href_link = '';//modules.php?name=FAQ&cat=1#f1
    // output

   return _mapTemplate($print, $module_name); 
}

/**
 * function : mapMy_eGallery()
 * @param  string $module_name Default 'My_eGallery'
 * @param  integer $map_limit Default '30'
 * @param  string $output Default 'echo'
 * @return string (Categories & items as formated html list <lu><li>)
 */
function mapMy_eGallery($module_name = 'My_eGallery', $map_limit = 30)
{
    global $prefix, $currentlang, $custom_title, $map_output;
    $who_view = 2;
    $print = array();
    $qry = "SELECT link.gid as cat_id, link.name as link_title, link.pid as link_id, 
            cat.gallname as cat_title, cat.description as cat_desc, link.counter as link_hits,
            if(link.description<>'',link.description,link.name) as link_desc
            FROM " . $prefix . "_gallery_pictures AS link
            LEFT JOIN " . $prefix . "_gallery_categories AS cat ON (link.gid = cat.gallid)
            WHERE cat.visible = " . intval($who_view) . "
            ORDER BY link.gid, link.pid  LIMIT " . intval($map_limit) . "
    ";
     $result = sql_query($qry);
     if (!$result) return;
     while ($row = sql_fetch_assoc($result)) {
     $row['link_desc'] = altDisplay($row['link_desc'], $row['link_title'], $row['link_hits']);
     $row['href_cat']  = 'modules.php?name=' . $module_name . '&amp;do=showgall&amp;gid=' . $row['cat_id'];
     $row['href_link'] = 'modules.php?name=' . $module_name . '&amp;do=showpic&amp;pid=' . $row['link_id'];
     $print[$row['cat_id']][] = $row;
}
    
     $href_cat  = '&amp;do=showgall&amp;gid=';//modules.php?name=My_eGallery&amp;do=showgall&amp;gid=2
     $href_link = '&amp;do=showpic&amp;pid=';//modules.php?name=My_eGallery&amp;do=showpic&amp;pid=3&orderby=dateD
    // output

   return _mapTemplate($print, $module_name); 
}

/**
 * function : mapeBoard()
 * @param  string $module_name Default 'eBoard'
 * @param  integer $map_limit Default '30'
 * @param  string $output Default 'echo'
 * @return string $out (Categories & items as list <lu><li>)
 */
function mapeBoard($module_name = 'eBoard', $map_limit = 30)
{
    global $prefix, $currentlang, $custom_title, $map_output;
    $where ="";
    if (!MX_IS_ADMIN && !MX_IS_USER) {
         $where = " WHERE cat.status='on' AND cat.private=''";
    }
    elseif (!MX_IS_ADMIN && MX_IS_USER){
          $where = " WHERE cat.status='on'";
    }

    
    $print = array();
    $qry = "SELECT link.fid as cat_id, link.subject as link_title, link.tid as link_id, 
            link.views as link_hits, cat.name as cat_title, cat.name as cat_desc,
            link.message as link_desc
            FROM " . $prefix . "_eboard_threads AS link
            LEFT JOIN " . $prefix . "_eboard_forums AS cat ON (link.fid = cat.fid)
            " . $where . "
            ORDER BY link.dateline DESC, cat.displayorder LIMIT " . intval($map_limit) . "
    ";
     $result = sql_query($qry);
     if (!$result) return;
     while ($row = sql_fetch_assoc($result)) {
     $row['link_desc'] = altDisplay($row['link_desc'], $row['link_title'], $row['link_hits']);
     $row['link_desc']  = htmlentities ($row['link_desc']);
     $row['link_title'] = htmlentities ($row['link_title']);
     $row['href_cat']  = 'modules.php?name=' . $module_name . '&amp;file=forumdisplay&amp;fid=' . $row['cat_id'];
     $row['href_link'] = 'modules.php?name=' . $module_name . '&amp;file=viewthread&amp;tid=' . $row['link_id'];

     $print[$row['cat_id']][] = $row;
}
     $href_cat = '&amp;file=forumdisplay&amp;fid=';//&amp;file=forumdisplay&amp;fid=2
     $href_link ='&amp;file=viewthread&amp;tid=';//&amp;file=viewthread&amp;tid=1
    // output

   return _mapTemplate($print, $module_name); 
}

/**
 * function mapForum()
 * @param $module_name Forum 
 * @param $print 
 * @return string 
 */ 
  function mapForum($module_name = 'Forum', $map_limit)
{
     global $context, $settings, $txt, $ID_MEMBER, $prefix, $mxsmf, $map_output;
     global $user_info, $modSettings, $func;
     if (!isset($default_group)) $GLOBALS['default_group'] = '1';//Bug in modules/Forum/mx_functions.php:741
     include_once (PMX_MODULES_DIR . DS . $module_name ."/mx_SSI.php");
     $scripturl = 'modules.php?name=' . $module_name;
    $qry = "
		SELECT link.ID_BOARD as cat_id , link.subject as link_title, link.smileysEnabled, link.ID_TOPIC, link.ID_MSG, link.ID_BOARD, 
        b.name AS cat_title, LEFT(link.body, 384) AS link_desc, t.ID_LAST_MSG as link_id, t.numViews as link_hits
            FROM " . $prefix . "_smf_topics AS t 
            LEFT JOIN " . $prefix . "_smf_messages AS link ON (link.ID_MSG = t.ID_FIRST_MSG)
            LEFT JOIN " . $prefix . "_smf_boards AS b ON (link.ID_BOARD = b.ID_BOARD)
            WHERE  ".$user_info['query_see_board']."
            ORDER BY link.ID_MSG DESC
            LIMIT " . $map_limit . " ";
    $result = sql_query($qry);
    if (!$result) return;   
	$print = array();
    while ($row = sql_fetch_assoc($result))
	{
		$row['link_desc'] = strip_tags(strtr(parse_bbc($row['link_desc'], $row['smileysEnabled'], $row['link_id']), array('<br />' => '&#10;')));
		$row['link_desc'] = preg_replace('/\s\s+/', ' ', $row['link_desc']);
        if ($func['strlen']($row['link_desc']) > 128)
			$row['link_desc'] = $func['substr']($row['link_desc'], 0, 128) . '...';
        $row['link_desc'] = altDisplay($row['link_desc'], $row['link_title'], $row['link_hits']);
        $row['link_desc']  = htmlentities ($row['link_desc']);
        $row['link_title'] = htmlentities ($row['link_title']);
        $row['href_cat']  = 'modules.php?name=' . $module_name . '&amp;board=' . $row['cat_id'] . '.0';//modules.php?name=Forum&board=4.0
		$row['href_link'] = 'modules.php?name=' . $module_name . '&amp;topic=' . $row['ID_TOPIC'] . '.msg'.$row['link_id'] .'#msg'.$row['link_id'];//modules.php?name=Forum&topic=1.msg0;boardseen#new

        $print[$row['cat_id']][] = $row;

	}
    //here we free a part of memory. because these variables contain much information
	unset($context, $settings, $txt, $mxsmf, $user_info, $modSettings, $func);
   return _mapTemplate($print, $module_name); 

	
}


/**
 * mapGallery()
 * 
 * @param string $module_name
 * @param integer $map_limit
 * @return
 */
function mapGallery($module_name = 'Gallery', $map_limit)
{
    global $map_output, $uinfo;
    if (!defined("IN_COPPERMINE")) define("IN_COPPERMINE",1);
    include_once(PMX_MODULES_DIR .DS . $module_name . '/include/config.inc.php');
    $prefix = $CONFIG['TABLE_PREFIX'] ;
    $who_view = array(0, $uinfo['user_ingroup'] + 5);
    if (MX_IS_USER) $who_view[] = 2;
    $who_view = implode(',',$who_view);
    $print = array();
        $qry = "SELECT link.aid as cat_id, if(link.title<>'',link.title,link.filename) as link_title, link.pid as link_id, 
            cat.title as cat_title, cat.description as cat_desc, link.hits as link_hits, link.position as link_pos,
            if(link.caption<>'',link.caption,if(link.title<>'',link.title,link.filename)) as link_desc, link.owner_id as owner_id
            FROM " . $prefix . "pictures AS link
            LEFT JOIN " . $prefix . "albums AS cat ON (link.aid = cat.aid)
            WHERE (cat.visibility IN(" . $who_view . ") OR link.owner_id='" . intval($uinfo['uid']) . "') AND link.approved='yes'
            ORDER BY link.aid, link.pid  LIMIT " . intval($map_limit) . "
    ";
     $result = sql_query($qry);
     if (!$result) return;
     while ($row = sql_fetch_assoc($result)) {
     $album_owner = mxGetUserDataFromUid($row['owner_id']);
     $row['cat_title'] =$row['cat_title'] .' ( ' . $album_owner['uname'].' )';
     $row['link_desc'] = altDisplay($row['link_desc'], $row['link_title'], $row['link_hits']);
     $row['link_desc']  = htmlentities ($row['link_desc']);
     $row['link_title'] = htmlentities ($row['link_title']);
     $row['href_cat']  = 'modules.php?name=' . $module_name . '&amp;act=thumbnails&amp;album=' . $row['cat_id'];
     $row['href_link'] = 'modules.php?name=' . $module_name . '&amp;act=displayimage&amp;pos=-' . $row['link_id'];
     $print[$row['cat_id']][] = $row;
}
    return _mapTemplate($print, $module_name); 
}
/**
 * function _mapSmfTemplate()
 * @param $module_name 
 * @param $print 
 * @return string 
 */ 
 function _mapTemplate($print, $module_name){
global $map_output;
if (!is_array($print) || empty($print) || !isset($module_name)) return;
if ($map_output !='echo') {
     $sitemap = array();
     $sitemap[$module_name] = $print;
     return $sitemap;
}

?>

<ul>

<?php foreach ($print as $cat_list ): ?>
         <?php while (list($key, $val) = each($cat_list)) : ?>
         <li>
            <a href="<?php echo $val['href_cat']; ?>" title="<?php echo $val['cat_title']; ?>"><?php echo $val['cat_title']; ?></a>
<?php if(is_array($cat_list) && !empty($cat_list)): ?>
            <ul>
<?php foreach ($cat_list as $value): ?>
                <li>
                <a href="<?php echo $value['href_link']; ?>" title="<?php echo $value['link_desc']; ?>"><?php echo $value['link_title']; ?></a>
                </li>
<?php endforeach ?>
            </ul>
<?php endif ?>
        </li>	
 <?php endwhile ?>
<?php endforeach ?>
</ul>
<?php
#########################################################
	
	
}
/**
 * Function listAllowedModules()
 * This function return an array whith all allowed modules
 * @return array() whith Module_name as key AND mid, custum_title, main_id(name of display block) as values
 * 
 */

function listAllowedModules(){
    global $prefix;
    $modules = array();
	$modules_list = sql_query("SELECT mid, title, custom_title, main_id FROM " . $prefix . "_modules");
    while (list($mid, $modulename, $custom_title, $main_id) = sql_fetch_row($modules_list)) {
        if (mxModuleAllowed($modulename)){
        $custom_title = ((empty($custom_title)) ? str_replace("_", " ", $modulename) : $custom_title);
           if (defined($custom_title)) {
            $custom_title = html_entity_decode(constant($custom_title)) ;
             }
           $module = array('mid' => $mid,
                           'modulename' => $modulename,
                           'custom_title' => $custom_title,
                           'main_id' => $main_id );
           $modules[$modulename] = $module;
           }
         }
        return $modules ;
     }
     
/**
 * arrayOrderBy()
 * 
 * @param array $array
 * @param mixed $value
 * @return $array ordered by $value
 */
function arrayOrderBy($array = '', $value = '')
{
    $args = func_get_args();
    $data = array_shift($args);
    foreach ($args as $n => $field) {
        if (is_string($field)) {
            $tmp = array();
            foreach ($data as $key => $row)
                $tmp[$key] = $row[$field];
            $args[$n] = $tmp;
            }
    }
    $args[] = &$data;
    call_user_func_array('array_multisort', $args);
    return array_pop($args);
}


/**
 * sitemapOutput()
 * 
 * @return void
 */
function sitemapOutput(){
  global $module_name, $use_treeview, $rssFeed, $specificargarray,
  $excludedmodules, $map_limit, $treeview_use_cookie, $bgcolor1, $bgcolor2,
  $treeview_use_anime, $treeview_anime_speed;
  $langlist = theme_show_languageflags();
  $rssLink = '';
  $ul_id = '';
  $no_javascript = '';
  $modules = listAllowedModules();  
  if ($use_treeview) {
   pmxHeader_Site_map::add_treeview($treeview_use_cookie);//
  $ul_id = ' id="tree"';
  }
?>
<?php if(version_compare(PMX_VERSION, '0.1.12', '<')): ?>
<script type="text/javascript">
	$(function() {
			$("#tree").treeview({
				collapsed: true,
				<?php echo (($treeview_use_anime == 1) ?   'animated: "'.$treeview_anime_speed.'",' : '') ?>
				control:"#sidetreecontrol",
				<?php echo (($treeview_use_cookie == 1) ?   'persist: "cookie"' : '') ?>
			});
		})
</script>
<?php endif ?>
<a name="haut"></a>
<?php title(_SITEMAPHEADER); ?>
<div id="sitemap">
<?php if ($GLOBALS["multilingual"] == 1): ?>
<?php echo ucfirst(_LANGUAGES); ?> <br /><br /><?php echo $langlist; ?><br /><br />
<?php endif ?>
<noscript><span><strong><?php echo (defined("_JSSHOULDBEACTIVE") ? _JSSHOULDBEACTIVE : 'To use this feature, javascript must be enabled.');// _JSSHOULDBEACTIVE not defined in pmx 0.1.11 ?></strong></span></noscript>
<?php if ($use_treeview):?>
<div id="sidetreecontrol"><a href="<?php echo $_SERVER['REQUEST_URI']; ?>#"><?php echo ucfirst(_EXPAND2COLLAPSE_TITLE_C); ?></a> | <a href="<?php echo $_SERVER['REQUEST_URI']; ?>#"><?php echo ucfirst(_EXPAND2COLLAPSE_TITLE_E); ?></a></div>
<?php endif ?>
<!--Start List All Modules -->
<ul<?php echo $ul_id; ?>>
        <li><a href="./" title="<?php echo _HOME; ?>"><strong><?php echo _HOME; ?></strong></a></li>
<?php //mapAdmin();// if you like show admin menu as list uncomment this line (only for super-admin) ?>
<?php
foreach ($modules as $module ) {
$specificmodulearg = ((array_key_exists($module['modulename'], $specificargarray)) ? $specificargarray[$module['modulename']] : '');
if (array_key_exists($module['modulename'], $rssFeed) && ($GLOBALS['backend_active'])) 
        $rssLink = '&nbsp;&nbsp;&nbsp;<a href="' . MX_BASE_URL . $rssFeed[$module['modulename']] .'">' . IMG_RSS . '</a>';
       
if (!in_array($module['modulename'], $excludedmodules)):?>
                    <li>
                    <a href="<?php echo MX_BASE_URL; ?>modules.php?name=<?php echo $module['modulename']; ?>"  
                    title="<?php echo $module['custom_title']; ?>"><strong><?php echo $module['custom_title']; ?></strong></a>

        <?php echo (isset($rssLink) ? $rssLink : ''); ?>
           <?php callMapModule($module['modulename'], $map_limit, $specificmodulearg); ?>
                    </li>

<?php endif;
unset($rssLink);
}
?>
</ul>
<!--End List All Modules -->

<a href="#haut">
<img alt="<?php echo _MAPPAGEUP; ?>" src="modules/<?php echo $module_name; ?>/images/page_up.gif" title="<?php echo _MAPPAGEUP; ?>" /></a>
</div>

<?php
	}

?>