<?php
/**
 * pragmaMx  Content Management System
 * Copyright (c) 2010 pragmaMx Dev Team - http://pragmaMx.org
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
defined('mxMainFileLoaded') or die('access denied');
/**
 * -------------MODIFY HERE TO CUSTOMIZE THE SITEMAP------
 */
 
/**
 *  Put here the modules you want to exclude from the list
 */ 
$excludedmodules = array(basename(dirname(__file__)), 
                        'Userinfo',
                        'Members_List', 
                        'Your_Account', 
                        'Statistics',
                        'Private_Messages', 
                        'UserGuest', 
                        'blank_Home');//ex: array('Downloads', 'News'); 


/**
 *  Put here the modules you want to exclude from the list
 */ 
/**
 * If you should modify some function, add the additional parameter here
 * 'module_name' => 'parameter' ex 'Downloads' => 'TopDownloads')
 * Here we have only one parameter for search function.
 */
$specificargarray = array(
               'Search' => 'Simple');//Advanced OR Simple

/**
 *  Number of items for each modules. ex (10 links for Downloads and 10 posts for Furum, 10 pictures .....)
 */
$map_limit = 10; // for humans 
$map_limit_bots = 50; // for robots (crawler) , good for SEO

/**
 *  the order of modules list. by modulename or costum_title
 *  ONLY IF YOU HAVE A MULTILINGUAL MODULE TITLE. see http://www.pragmamx.org/changes_full.txt  #01.11.2010 / 1.12 RC2
 *  otherwise this variable is worthless.
 */
$module_order_by = 'modulename'; //
 
/**
 *  show link alt attribute as 1:title(whit hits if exist) 0:description //'mouse Hover'
 */
$link_alt = 1; 
/**
 *  Number of caracters displaed as alt attribute description
 */
$link_alt_long = 100;

/**
 *  Treeview 1.4 - jQuery plugin to hide and show branches of a tree
 *  ( http://www.dynamicdrive.com/dynamicindex1/treeview/ )
 */
$use_treeview = 1; //active = 1 inactive = 0 , if inactive,  all the parameters below are ignored
$treeview_use_cookie = 1; //uses cookies to save the current state of the tree (opened or closed)
$treeview_use_anime  = 1; //1:animated menu 0:no animation
$treeview_anime_speed = 'fast'; //"slow", "normal", "fast",
/**
 * ---------END-MODIFY HERE TO CUSTOMIZE THE SITEMAP------
 */
 
 $rssFeed = array(
               'Downloads' => 'backend.php?op=downs',
               'News'      => 'backend.php?op=story',
               'Web_Links' => 'backend.php?op=link',
               'Forum'     => 'modules.php?name=Forum&amp;type=rss;action=.xml'
);

 define('IMG_RSS','
 <img width="24" height="10" alt="' . _SUBSCRIBETORSSFEED . '" 
     src="modules/'.basename(dirname(__file__)).'/images/rss.jpg" 
        title="' . _SUBSCRIBETORSSFEED . '" />');
  
$map_output = 'echo'; // 'echo', 'array'; default = 'echo'

//bots like "google" have no problem with the page length. So we send them all links ...

$agent = "x" . strtolower(MX_USER_AGENT);
if ((strpos($agent, "bot")) || (strpos($agent, "google")) || (strpos($agent, "slurp")) || 
    (strpos($agent, "scooter")) || (strpos($agent, "spider")) || (strpos($agent, "infoseek"))) 
    $map_limit = $map_limit_bots;
    unset($agent);
    
 /*   
if(preg_match('/bot|spider|AllTheWeb|yahoo|Seeker|Lycos|Crawler/i', MX_USER_AGENT))$map_limit = $map_limit_bots;

*/
?>